'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var babelPluginJsxDomExpressions = require('babel-plugin-jsx-dom-expressions');
var S = _interopDefault(require('s-js'));

function shallowDiff(a, b) {
  let sa = new Set(a), sb = new Set(b);
  return [a.filter(i => !sb.has(i)), (b.filter(i => !sa.has(i)))];
}

const r = babelPluginJsxDomExpressions.createRuntime({wrap: S.makeComputationNode});

function selectWhen(signal, handler) {
  return list => {
    S.on(signal, element => {
      const model = signal();
      if (element) handler(element, false);
      if (element = model && list().find(el => el.model === model)) handler(element, true);
      return element;
    });
    return list;
  }
}

function selectEach(signal, handler) {
  return list => {
    S.on(signal, elements => {
      const models = signal(),
        newElements = list().filter(el => models.indexOf(el.model) > -1),
        [additions, removals] = shallowDiff(newElements, elements);
      additions.forEach(el => handler(el, true));
      removals.forEach(el => handler(el, false));
      return newElements;
    });
    return list;
  }
}

exports.r = r;
exports.selectWhen = selectWhen;
exports.selectEach = selectEach;
